#This calculates area under the curve for the DSI simulations for two or more molecule species.
#Edit the mollist varable if other molecules are of interest
#Present, it only evaluates the mean value (averaged over the entire morphology), but can also process other
# column by specifying a list of columns for meancol variable.
#This calculates the ratio of the results with respect to the 0dhpg condition specified in dhpgconc
#The input file is output from NRDPostAB to calculate region averages of a single molecule species.
import os
from numpy import *
from pylab import *
import sys

#give basic information such as directory, root name of the files, and list of molecules to be processed:

#specify complete name of file, excluding molecule name, can process multiple simulations
prefix=['Uchi12mar20-'+sys.argv[1]+'-']

duration=[['100ms','1s','5s'],['20sCa12-','20sCa12-3-','20sCa12-3-']]
dhpgconc=['0dhpg', '1dhpg','5dhpg','25dhpg']
outputprefix=['Uchi'+sys.argv[1]+'-']

#This list of molecules can be of arbitrary length.  
mollist=['Pkct', '2ag']   

#which columns of data do you want to process, e.g. submemb, etc.
#the last value will be replaced by 2nd to last column below.
meancol=[17]
basaltime=12000
stimtime=14000
endtime=39950

#*************Use assignments above to sum corresponding columns in files *******************
#this loop assigns the filenames
for filenm in range(len(prefix)):
    for mol in mollist:
        auc=zeros((len(dhpgconc),len(duration[0])))
        ratio=zeros((len(dhpgconc)-1,len(duration[0])))
        for dhpg in range(len(dhpgconc)):
            for dur in range(len(duration[0])):
                fullfilename=prefix[filenm]+duration[0][dur]+dhpgconc[dhpg]+duration[1][dur]+mol+'_avg.txt'
                
#this loop reads in the data arrays and adds them together
                data=loadtxt(fullfilename,skiprows=1)
                print fullfilename,data.shape
                
#make sure the second to last column is identified, and extract the time column
                meancol=data.shape[1]-2
                time=data[:,0]
                
#calculate area under the curve from the beginning of stimulation through when the response returns to basal.
                dt=time[1]-time[0]
                basalend=basaltime/dt
                stimsample=stimtime/dt
                endsample=endtime/dt
                auc[dhpg,dur]=(data[stimsample:endsample,meancol].mean()-data[0:basalend,meancol].mean())
        #End of first for dhpg and for dur loop

        for dhpg in range(len(dhpgconc)-1):
            for dur in range(len(duration[0])):
                ratio[dhpg,dur]=auc[dhpg+1,dur]/auc[0,dur]

#	outdata=column_stack((time, headstimdata, newdata[:,meancol]))

        outfname=outputprefix[filenm]+mol+'-auc.txt'
        print outfname
        savetxt(outfname, auc, fmt='%.4f', delimiter=' ')
        outfname=outputprefix[filenm]+mol+'-ratio.txt'
        savetxt(outfname, ratio, fmt='%.4f', delimiter=' ')

